package com.hfkj.dao;

import com.hfkj.entity.BsDiscountPkRel;
import com.hfkj.entity.BsDiscountPkRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsDiscountPkRelMapper extends BsDiscountPkRelMapperExt {
    @SelectProvider(type=BsDiscountPkRelSqlProvider.class, method="countByExample")
    long countByExample(BsDiscountPkRelExample example);

    @DeleteProvider(type=BsDiscountPkRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsDiscountPkRelExample example);

    @Delete({
        "delete from bs_discount_pk_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_discount_pk_rel (discount_pk_no, `number`, ",
        "discount_no, discount_name, ",
        "discount_type, discount_condition, ",
        "discount_price, use_scope, ",
        "receive_expiration_date, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{discountPkNo,jdbcType=VARCHAR}, #{number,jdbcType=INTEGER}, ",
        "#{discountNo,jdbcType=VARCHAR}, #{discountName,jdbcType=VARCHAR}, ",
        "#{discountType,jdbcType=INTEGER}, #{discountCondition,jdbcType=DECIMAL}, ",
        "#{discountPrice,jdbcType=DECIMAL}, #{useScope,jdbcType=VARCHAR}, ",
        "#{receiveExpirationDate,jdbcType=INTEGER}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsDiscountPkRel record);

    @InsertProvider(type=BsDiscountPkRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsDiscountPkRel record);

    @SelectProvider(type=BsDiscountPkRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_pk_no", property="discountPkNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="number", property="number", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_no", property="discountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="use_scope", property="useScope", jdbcType=JdbcType.VARCHAR),
        @Result(column="receive_expiration_date", property="receiveExpirationDate", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsDiscountPkRel> selectByExample(BsDiscountPkRelExample example);

    @Select({
        "select",
        "id, discount_pk_no, `number`, discount_no, discount_name, discount_type, discount_condition, ",
        "discount_price, use_scope, receive_expiration_date, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_discount_pk_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_pk_no", property="discountPkNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="number", property="number", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_no", property="discountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_name", property="discountName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_type", property="discountType", jdbcType=JdbcType.INTEGER),
        @Result(column="discount_condition", property="discountCondition", jdbcType=JdbcType.DECIMAL),
        @Result(column="discount_price", property="discountPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="use_scope", property="useScope", jdbcType=JdbcType.VARCHAR),
        @Result(column="receive_expiration_date", property="receiveExpirationDate", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsDiscountPkRel selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsDiscountPkRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsDiscountPkRel record, @Param("example") BsDiscountPkRelExample example);

    @UpdateProvider(type=BsDiscountPkRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsDiscountPkRel record, @Param("example") BsDiscountPkRelExample example);

    @UpdateProvider(type=BsDiscountPkRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsDiscountPkRel record);

    @Update({
        "update bs_discount_pk_rel",
        "set discount_pk_no = #{discountPkNo,jdbcType=VARCHAR},",
          "`number` = #{number,jdbcType=INTEGER},",
          "discount_no = #{discountNo,jdbcType=VARCHAR},",
          "discount_name = #{discountName,jdbcType=VARCHAR},",
          "discount_type = #{discountType,jdbcType=INTEGER},",
          "discount_condition = #{discountCondition,jdbcType=DECIMAL},",
          "discount_price = #{discountPrice,jdbcType=DECIMAL},",
          "use_scope = #{useScope,jdbcType=VARCHAR},",
          "receive_expiration_date = #{receiveExpirationDate,jdbcType=INTEGER},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsDiscountPkRel record);
}