package com.hfkj.dao;

import com.hfkj.entity.BsGasChannelPriceWeek;
import com.hfkj.entity.BsGasChannelPriceWeekExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsGasChannelPriceWeekMapper extends BsGasChannelPriceWeekMapperExt {
    @SelectProvider(type=BsGasChannelPriceWeekSqlProvider.class, method="countByExample")
    long countByExample(BsGasChannelPriceWeekExample example);

    @DeleteProvider(type=BsGasChannelPriceWeekSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsGasChannelPriceWeekExample example);

    @Delete({
        "delete from bs_gas_channel_price_week",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_gas_channel_price_week (gas_channel_type, weeks, ",
        "oil_type, oil_type_name, ",
        "oil_no, price_rate, ",
        "service_fee_rate, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{gasChannelType,jdbcType=INTEGER}, #{weeks,jdbcType=INTEGER}, ",
        "#{oilType,jdbcType=INTEGER}, #{oilTypeName,jdbcType=VARCHAR}, ",
        "#{oilNo,jdbcType=VARCHAR}, #{priceRate,jdbcType=DECIMAL}, ",
        "#{serviceFeeRate,jdbcType=DECIMAL}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsGasChannelPriceWeek record);

    @InsertProvider(type=BsGasChannelPriceWeekSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsGasChannelPriceWeek record);

    @SelectProvider(type=BsGasChannelPriceWeekSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="gas_channel_type", property="gasChannelType", jdbcType=JdbcType.INTEGER),
        @Result(column="weeks", property="weeks", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type", property="oilType", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type_name", property="oilTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no", property="oilNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="price_rate", property="priceRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="service_fee_rate", property="serviceFeeRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsGasChannelPriceWeek> selectByExample(BsGasChannelPriceWeekExample example);

    @Select({
        "select",
        "id, gas_channel_type, weeks, oil_type, oil_type_name, oil_no, price_rate, service_fee_rate, ",
        "`status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from bs_gas_channel_price_week",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="gas_channel_type", property="gasChannelType", jdbcType=JdbcType.INTEGER),
        @Result(column="weeks", property="weeks", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type", property="oilType", jdbcType=JdbcType.INTEGER),
        @Result(column="oil_type_name", property="oilTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_no", property="oilNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="price_rate", property="priceRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="service_fee_rate", property="serviceFeeRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsGasChannelPriceWeek selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsGasChannelPriceWeekSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsGasChannelPriceWeek record, @Param("example") BsGasChannelPriceWeekExample example);

    @UpdateProvider(type=BsGasChannelPriceWeekSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsGasChannelPriceWeek record, @Param("example") BsGasChannelPriceWeekExample example);

    @UpdateProvider(type=BsGasChannelPriceWeekSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsGasChannelPriceWeek record);

    @Update({
        "update bs_gas_channel_price_week",
        "set gas_channel_type = #{gasChannelType,jdbcType=INTEGER},",
          "weeks = #{weeks,jdbcType=INTEGER},",
          "oil_type = #{oilType,jdbcType=INTEGER},",
          "oil_type_name = #{oilTypeName,jdbcType=VARCHAR},",
          "oil_no = #{oilNo,jdbcType=VARCHAR},",
          "price_rate = #{priceRate,jdbcType=DECIMAL},",
          "service_fee_rate = #{serviceFeeRate,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsGasChannelPriceWeek record);
}