package com.hfkj.dao;

import com.hfkj.entity.BsGasOrderSpread;
import com.hfkj.entity.BsGasOrderSpreadExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsGasOrderSpreadMapper extends BsGasOrderSpreadMapperExt {
    @SelectProvider(type=BsGasOrderSpreadSqlProvider.class, method="countByExample")
    long countByExample(BsGasOrderSpreadExample example);

    @DeleteProvider(type=BsGasOrderSpreadSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsGasOrderSpreadExample example);

    @Delete({
        "delete from bs_gas_order_spread",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_gas_order_spread (order_no, gains_rebate_user_id, ",
        "gains_rebate_rate, gains_rebate_amount, ",
        "gains_rebate_one_user_id, gains_rebate_one_rate, ",
        "gains_rebate_one_amount, gains_rebate_two_user_id, ",
        "gains_rebate_two_rate, gains_rebate_two_amount, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{orderNo,jdbcType=VARCHAR}, #{gainsRebateUserId,jdbcType=BIGINT}, ",
        "#{gainsRebateRate,jdbcType=DECIMAL}, #{gainsRebateAmount,jdbcType=DECIMAL}, ",
        "#{gainsRebateOneUserId,jdbcType=BIGINT}, #{gainsRebateOneRate,jdbcType=DECIMAL}, ",
        "#{gainsRebateOneAmount,jdbcType=DECIMAL}, #{gainsRebateTwoUserId,jdbcType=BIGINT}, ",
        "#{gainsRebateTwoRate,jdbcType=DECIMAL}, #{gainsRebateTwoAmount,jdbcType=DECIMAL}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsGasOrderSpread record);

    @InsertProvider(type=BsGasOrderSpreadSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsGasOrderSpread record);

    @SelectProvider(type=BsGasOrderSpreadSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="gains_rebate_user_id", property="gainsRebateUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="gains_rebate_rate", property="gainsRebateRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_amount", property="gainsRebateAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_one_user_id", property="gainsRebateOneUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="gains_rebate_one_rate", property="gainsRebateOneRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_one_amount", property="gainsRebateOneAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_two_user_id", property="gainsRebateTwoUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="gains_rebate_two_rate", property="gainsRebateTwoRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_two_amount", property="gainsRebateTwoAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsGasOrderSpread> selectByExample(BsGasOrderSpreadExample example);

    @Select({
        "select",
        "id, order_no, gains_rebate_user_id, gains_rebate_rate, gains_rebate_amount, ",
        "gains_rebate_one_user_id, gains_rebate_one_rate, gains_rebate_one_amount, gains_rebate_two_user_id, ",
        "gains_rebate_two_rate, gains_rebate_two_amount, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_gas_order_spread",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="gains_rebate_user_id", property="gainsRebateUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="gains_rebate_rate", property="gainsRebateRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_amount", property="gainsRebateAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_one_user_id", property="gainsRebateOneUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="gains_rebate_one_rate", property="gainsRebateOneRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_one_amount", property="gainsRebateOneAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_two_user_id", property="gainsRebateTwoUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="gains_rebate_two_rate", property="gainsRebateTwoRate", jdbcType=JdbcType.DECIMAL),
        @Result(column="gains_rebate_two_amount", property="gainsRebateTwoAmount", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsGasOrderSpread selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsGasOrderSpreadSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsGasOrderSpread record, @Param("example") BsGasOrderSpreadExample example);

    @UpdateProvider(type=BsGasOrderSpreadSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsGasOrderSpread record, @Param("example") BsGasOrderSpreadExample example);

    @UpdateProvider(type=BsGasOrderSpreadSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsGasOrderSpread record);

    @Update({
        "update bs_gas_order_spread",
        "set order_no = #{orderNo,jdbcType=VARCHAR},",
          "gains_rebate_user_id = #{gainsRebateUserId,jdbcType=BIGINT},",
          "gains_rebate_rate = #{gainsRebateRate,jdbcType=DECIMAL},",
          "gains_rebate_amount = #{gainsRebateAmount,jdbcType=DECIMAL},",
          "gains_rebate_one_user_id = #{gainsRebateOneUserId,jdbcType=BIGINT},",
          "gains_rebate_one_rate = #{gainsRebateOneRate,jdbcType=DECIMAL},",
          "gains_rebate_one_amount = #{gainsRebateOneAmount,jdbcType=DECIMAL},",
          "gains_rebate_two_user_id = #{gainsRebateTwoUserId,jdbcType=BIGINT},",
          "gains_rebate_two_rate = #{gainsRebateTwoRate,jdbcType=DECIMAL},",
          "gains_rebate_two_amount = #{gainsRebateTwoAmount,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsGasOrderSpread record);
}