package com.hfkj.dao;

import com.hfkj.entity.BsGasOrderSpread;
import com.hfkj.entity.BsGasOrderSpreadExample.Criteria;
import com.hfkj.entity.BsGasOrderSpreadExample.Criterion;
import com.hfkj.entity.BsGasOrderSpreadExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsGasOrderSpreadSqlProvider {

    public String countByExample(BsGasOrderSpreadExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_gas_order_spread");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsGasOrderSpreadExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_gas_order_spread");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsGasOrderSpread record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_gas_order_spread");
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGainsRebateUserId() != null) {
            sql.VALUES("gains_rebate_user_id", "#{gainsRebateUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateRate() != null) {
            sql.VALUES("gains_rebate_rate", "#{gainsRebateRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateAmount() != null) {
            sql.VALUES("gains_rebate_amount", "#{gainsRebateAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateOneUserId() != null) {
            sql.VALUES("gains_rebate_one_user_id", "#{gainsRebateOneUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateOneRate() != null) {
            sql.VALUES("gains_rebate_one_rate", "#{gainsRebateOneRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateOneAmount() != null) {
            sql.VALUES("gains_rebate_one_amount", "#{gainsRebateOneAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateTwoUserId() != null) {
            sql.VALUES("gains_rebate_two_user_id", "#{gainsRebateTwoUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateTwoRate() != null) {
            sql.VALUES("gains_rebate_two_rate", "#{gainsRebateTwoRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateTwoAmount() != null) {
            sql.VALUES("gains_rebate_two_amount", "#{gainsRebateTwoAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsGasOrderSpreadExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_no");
        sql.SELECT("gains_rebate_user_id");
        sql.SELECT("gains_rebate_rate");
        sql.SELECT("gains_rebate_amount");
        sql.SELECT("gains_rebate_one_user_id");
        sql.SELECT("gains_rebate_one_rate");
        sql.SELECT("gains_rebate_one_amount");
        sql.SELECT("gains_rebate_two_user_id");
        sql.SELECT("gains_rebate_two_rate");
        sql.SELECT("gains_rebate_two_amount");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_gas_order_spread");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsGasOrderSpread record = (BsGasOrderSpread) parameter.get("record");
        BsGasOrderSpreadExample example = (BsGasOrderSpreadExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order_spread");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGainsRebateUserId() != null) {
            sql.SET("gains_rebate_user_id = #{record.gainsRebateUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateRate() != null) {
            sql.SET("gains_rebate_rate = #{record.gainsRebateRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateAmount() != null) {
            sql.SET("gains_rebate_amount = #{record.gainsRebateAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateOneUserId() != null) {
            sql.SET("gains_rebate_one_user_id = #{record.gainsRebateOneUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateOneRate() != null) {
            sql.SET("gains_rebate_one_rate = #{record.gainsRebateOneRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateOneAmount() != null) {
            sql.SET("gains_rebate_one_amount = #{record.gainsRebateOneAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateTwoUserId() != null) {
            sql.SET("gains_rebate_two_user_id = #{record.gainsRebateTwoUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateTwoRate() != null) {
            sql.SET("gains_rebate_two_rate = #{record.gainsRebateTwoRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateTwoAmount() != null) {
            sql.SET("gains_rebate_two_amount = #{record.gainsRebateTwoAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order_spread");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("gains_rebate_user_id = #{record.gainsRebateUserId,jdbcType=BIGINT}");
        sql.SET("gains_rebate_rate = #{record.gainsRebateRate,jdbcType=DECIMAL}");
        sql.SET("gains_rebate_amount = #{record.gainsRebateAmount,jdbcType=DECIMAL}");
        sql.SET("gains_rebate_one_user_id = #{record.gainsRebateOneUserId,jdbcType=BIGINT}");
        sql.SET("gains_rebate_one_rate = #{record.gainsRebateOneRate,jdbcType=DECIMAL}");
        sql.SET("gains_rebate_one_amount = #{record.gainsRebateOneAmount,jdbcType=DECIMAL}");
        sql.SET("gains_rebate_two_user_id = #{record.gainsRebateTwoUserId,jdbcType=BIGINT}");
        sql.SET("gains_rebate_two_rate = #{record.gainsRebateTwoRate,jdbcType=DECIMAL}");
        sql.SET("gains_rebate_two_amount = #{record.gainsRebateTwoAmount,jdbcType=DECIMAL}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsGasOrderSpreadExample example = (BsGasOrderSpreadExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsGasOrderSpread record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_gas_order_spread");
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGainsRebateUserId() != null) {
            sql.SET("gains_rebate_user_id = #{gainsRebateUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateRate() != null) {
            sql.SET("gains_rebate_rate = #{gainsRebateRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateAmount() != null) {
            sql.SET("gains_rebate_amount = #{gainsRebateAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateOneUserId() != null) {
            sql.SET("gains_rebate_one_user_id = #{gainsRebateOneUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateOneRate() != null) {
            sql.SET("gains_rebate_one_rate = #{gainsRebateOneRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateOneAmount() != null) {
            sql.SET("gains_rebate_one_amount = #{gainsRebateOneAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateTwoUserId() != null) {
            sql.SET("gains_rebate_two_user_id = #{gainsRebateTwoUserId,jdbcType=BIGINT}");
        }
        
        if (record.getGainsRebateTwoRate() != null) {
            sql.SET("gains_rebate_two_rate = #{gainsRebateTwoRate,jdbcType=DECIMAL}");
        }
        
        if (record.getGainsRebateTwoAmount() != null) {
            sql.SET("gains_rebate_two_amount = #{gainsRebateTwoAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsGasOrderSpreadExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}