package com.hfkj.dao;

import com.hfkj.entity.BsPayMer;
import com.hfkj.entity.BsPayMerExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsPayMerMapper extends BsPayMerMapperExt {
    @SelectProvider(type=BsPayMerSqlProvider.class, method="countByExample")
    long countByExample(BsPayMerExample example);

    @DeleteProvider(type=BsPayMerSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsPayMerExample example);

    @Delete({
        "delete from bs_pay_mer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_pay_mer (pay_mer_name, pay_mer_no, ",
        "pay_mer_key, `status`, ",
        "create_time, update_time, ",
        "ext_1, ext_2, ext_3)",
        "values (#{payMerName,jdbcType=VARCHAR}, #{payMerNo,jdbcType=VARCHAR}, ",
        "#{payMerKey,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsPayMer record);

    @InsertProvider(type=BsPayMerSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsPayMer record);

    @SelectProvider(type=BsPayMerSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="pay_mer_name", property="payMerName", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_mer_no", property="payMerNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_mer_key", property="payMerKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsPayMer> selectByExample(BsPayMerExample example);

    @Select({
        "select",
        "id, pay_mer_name, pay_mer_no, pay_mer_key, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from bs_pay_mer",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="pay_mer_name", property="payMerName", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_mer_no", property="payMerNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_mer_key", property="payMerKey", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsPayMer selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsPayMerSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsPayMer record, @Param("example") BsPayMerExample example);

    @UpdateProvider(type=BsPayMerSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsPayMer record, @Param("example") BsPayMerExample example);

    @UpdateProvider(type=BsPayMerSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsPayMer record);

    @Update({
        "update bs_pay_mer",
        "set pay_mer_name = #{payMerName,jdbcType=VARCHAR},",
          "pay_mer_no = #{payMerNo,jdbcType=VARCHAR},",
          "pay_mer_key = #{payMerKey,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsPayMer record);
}