package com.hfkj.dao;

import com.hfkj.entity.BsUserSpreadRel;
import com.hfkj.entity.BsUserSpreadRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsUserSpreadRelMapper extends BsUserSpreadRelMapperExt {
    @SelectProvider(type=BsUserSpreadRelSqlProvider.class, method="countByExample")
    long countByExample(BsUserSpreadRelExample example);

    @DeleteProvider(type=BsUserSpreadRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsUserSpreadRelExample example);

    @Delete({
        "delete from bs_user_spread_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_user_spread_rel (parent_user_id, user_id, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{parentUserId,jdbcType=BIGINT}, #{userId,jdbcType=BIGINT}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsUserSpreadRel record);

    @InsertProvider(type=BsUserSpreadRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsUserSpreadRel record);

    @SelectProvider(type=BsUserSpreadRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_user_id", property="parentUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsUserSpreadRel> selectByExample(BsUserSpreadRelExample example);

    @Select({
        "select",
        "id, parent_user_id, user_id, `status`, create_time, update_time, ext_1, ext_2, ",
        "ext_3",
        "from bs_user_spread_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_user_id", property="parentUserId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsUserSpreadRel selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsUserSpreadRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsUserSpreadRel record, @Param("example") BsUserSpreadRelExample example);

    @UpdateProvider(type=BsUserSpreadRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsUserSpreadRel record, @Param("example") BsUserSpreadRelExample example);

    @UpdateProvider(type=BsUserSpreadRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsUserSpreadRel record);

    @Update({
        "update bs_user_spread_rel",
        "set parent_user_id = #{parentUserId,jdbcType=BIGINT},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsUserSpreadRel record);
}