package com.hfkj.openapi.model.request;

import lombok.Data;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * 推送订单模型
 */
@Data
public class RequestOrderPushModel {

    @NotBlank(message = "appId必填项")
    private String appId;

    @NotNull(message =  "订单号必填项")
    private String orderNo;

    @NotNull(message =  "加油金额必填项")
    private BigDecimal refuelingAmount;

    @NotNull(message =  "油站编号必填项")
    private String gasNo;

    @NotNull(message =  "油号必填项")
    private String oilNo;

    @NotNull(message =  "枪号必填项")
    private String gunNo;

    @NotNull(message =  "用户手机号必填项")
    private String userPhone;

    @NotBlank(message = "签名必填项")
    private String sign;

}
